#!/usr/bin/perl

use strict;
use warnings;

use DBI;
my $dbh = DBI->connect('dbi:mysql:database=test', 'root', '');

use Data::Dumper;

foreach my $i ('', qw(groups_t groups_d groups_dt groups_td)) {
    my $query = "EXPLAIN SELECT STRAIGHT_JOIN DISTINCT g.id\n"
        ."\tFROM acl a, groups g". ($i? " USE INDEX ($i)": "") ."\n"
        ."\tWHERE (g.domain = 'queue' OR g.domain = 'system') AND g.type = a.type\n";
    my $res = $dbh->selectall_hashref( $query, 'table' );
    print $query;
    print Dumper($res->{'g'});
}

